/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 02 - Esercizio Proposto 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <math.h>

int main(void)
{
  float a, b, c, x, x1, x2;
  float re, im, delta, absDelta;

  /* data input */ 
  printf("Coefficient a: ");
  scanf("%f", &a);
  printf("Coefficient b: ");
  scanf("%f", &b);
  printf("Coefficient c: ");
  scanf("%f", &c);

  /* computation and output */
  if (a == 0) {
    if (b == 0) {
      if (c == 0) {
        /* 0 = 0 */
        printf("Undetermined identity.\n");
      } else {
        /* c = 0 */
        printf("Impossible identity.\n");
      }
    } else {
      /* bx + c = 0 */
      x = -c/b;
      printf("First degree equation; x = %f\n", x);
    }
  } else {
    /* now a!=0 (second degree equation) */
    delta = b*b - 4*a*c;
    absDelta = delta < 0 ? -delta : delta;
    re = -b/(2*a);
    im = sqrt(absDelta) / (2*a);

    if (delta > 0) {
      x1 = re + im;
      x2 = re - im;
      printf("Two real and dinstinct roots; x1 = %f, x2 = %f\n", x1, x2);
    } else if (delta == 0) {
      printf("Two real and coincident roots; x1 = x2 = %f\n", re);
    } else {
      /* delta < 0 */
      printf("Two complex and coniugate roots:\n");
      printf(" Real part = %f\n", re);
      printf(" Imaginary part = %f\n", im);
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
