/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 03 - Esercizio Proposto 08 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <math.h>

int main(void)
{
  int n, bit, flagPow2, flagNeg, flagInv;

  /* input decimal value */
  printf("Decimal value: ");
  scanf("%d", &n);

  /* if n<0 compute the opposite value and set flagNeg to 1 */
  if (n < 0) {
    n = -n;
    flagNeg = 1;
  } else {
    flagNeg = 0;
  }
  flagInv = 0;

  /* if n is negative and a power of 2 do not add MSB=1 */
  if ( (log(n)/log(2)) == ((int) (log(n)/log(2))) ) {
    flagPow2 = 1;
  } else {
    flagPow2 = 0;
  }

  /* compute and output binary digits */
  printf("Binary value (ca2, from LSB): ");
  while (n != 0) {
    bit = n % 2;
    if (flagNeg == 0) {
      /* positive number - nothing to do */
      printf("%d", bit);
    } else {
      /* negative number - compute ca2 */
      if (flagInv == 0) {
        /* print-out bits */
        printf("%d", bit);
        if (bit == 1) {
          flagInv = 1;
        }
      } else {
        /* print-out ca1 of bits: 0->1, 1->0 */
        printf("%d", 1 - bit);
      }
    }

    n = n / 2;
  }

  /* add MSB (when necessary) and new-line */
  if (flagPow2==1 && flagNeg==1) {
    printf("\n");
  } else {
    printf("%d\n", flagNeg);
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
