/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 03 - Esercizio Proposto 09 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

int main(void)
{
  int n, a, b, i;
  int sumDecimal, carryOld, carryNew, sum;

  /* number of bits */
  printf("Number of operand bits = ");
  scanf("%d", &n);

  /* initial carry (carry-in) */
  carryNew = 0;

  /* read bits and compute results (from LSB to MSB) */
  for (i=0; i<n; i++) {
    /* input i-th bit - first number */
    printf("A - Bit %d (0 or 1) = ", i);
    scanf("%d", &a);

    /* input i-th bit - second number */
    printf("B - Bit %d (0 or 1) = ", i);
    scanf("%d", &b);

    /* shift carry (keep track of last two values 
       to check overflow for complemented numbers) */
    carryOld = carryNew;

    /* decimal sum and conversion to binary values (sum and carry) */
    sumDecimal = a + b + carryOld;
    sum = sumDecimal % 2;
    carryNew = sumDecimal / 2;
    printf("=== Sum - Bit %d = %d\n", i, sum);
  }

  /* overflow detection */
  printf("Sum between pure numbers: ");
  if (carryNew == 1) {
    printf("overflow (carry = 1).\n");
  } else {
    printf("result OK (carry = 0).\n");
  }

  printf("Sum between numbers in 2 complement: ");
  if (carryOld != carryNew) {
    printf("overflow (different last two carries).\n");
  } else {
    printf("result OK (equal last two carries).\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
