/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 05 - Esercizio 11 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define SIZE 10

int main(void)
{
  int i, j, val, flag;
  int classes[SIZE];

  /* init array: zero frequency */
  for (i=0; i<SIZE; i++) {
    classes[i] = 0;
  }

  /* input phase: read numbers and collect statistics */
  printf("Input sequence:\n");
  flag = 1;
  do {
    printf("Value = ");
    scanf("%d", &val);

    /* check the value for termination */
    if (val<0 || val>=SIZE*SIZE) {
      flag = 0;
    } else {
      /* increase the class frequency */
      classes[val/SIZE]++;
    }
  } while (flag == 1);

  /* output phase */
  for (i=0; i<SIZE; i++) {
    printf("[%2d-%2d] ", i*SIZE, (i+1)*SIZE-1);
    for (j=0; j<classes[i]; j++) {
      printf("#");
    }
    printf("\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
