/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 05 - Esercizio 15 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N     13
#define ALIVE  1
#define EATEN  0

int main(void) 
{
  int i, w, init, count, num_eaten;
  int mouse[N], sequence[N];

  printf("White mouse position (1-%d)? ", N);
  scanf("%d", &w);

  init = 0;
  do {
    /* initially all mice are alive */
    for (i=0; i<N; i++) {
      mouse[i] = ALIVE;
    }

    /* start counting and eating from position init */
    i = init;
    num_eaten = 0;
    count = N-1;
    while (num_eaten < N) {
      if (mouse[i] == ALIVE) {
        count++;
      }
      if (count == N) {
        mouse[i] = EATEN;
        sequence[num_eaten] = i;
        num_eaten++;
        count = 0;
      }
      i = (i+1) % N;
    }
    if (sequence[N-1] != w-1) {
      init++;
    }
  } while (init<N && sequence[N-1]!=w-1);

  if (init < N) {
    printf("Sequence: ");
    for (i=0; i<N; i++) {
      printf("%d ", sequence[i]+1);
    }
    printf("\n");
  } else {
    printf("No solution found.\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
