/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 05 - Esercizio Proposto 06 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N 4

int main(void)
{
  int v1[N], v2[N], v3[N];
  int i, j, val, numEqual, maxEqual;

  /* input v1 and v2 */
  printf("Input v1:\n");
  for (i=0; i<N; i++) {
    printf("v1[%d] = ", i);
    scanf("%d", &v1[i]);
  }  
  print ("Input v2:\n");
  for (i=0; i<N; i++) {
    printf("v2[%d] = ", i);
    scanf("%d", &v2[i]);
  }  

  /* create N rotations */
  maxEqual = 0;
  for (i=0; i<N; i++) {
    /* right shift v2 elements by one position */
    val = v2[N-1];
    for (j=N-1; j>0; j--) {
      v2[j] = v2[j-1];
    }
    v2[0] = val;

    /* check */
    numEqual = 0;
    for (j=0; j<N; j++) {
      if (v1[j] == v2[j]) {
        numEqual++;
      }
    }

    /* if on maximum, copy v2 into v3 */
    if (numEqual > maxEqual) {
      maxEqual = numEqual;
      for (j=0; j<N; j++) {
        v3[j] = v2[j];
      }
    }
  }

  /* final output */
  printf("Number of equal elements = %d\n", maxEqual);
  if (maxEqual > 0) {
    printf("Rotation:\n");
    for (i=0; i<N; i++) {
      printf("v2[%d] = %d\n", i, v3[i]);
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
