/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 05 - Esercizio Proposto 06 - Soluzione 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N 4

int main(void)
{
  int v1[N], v2[N];
  int numEqual, maxEqual, maxRotation;
  int i, idx1, idx2;

  /* input v1 and v2 */
  printf("Input v1:\n");
  for (i=0; i<N; i++) {
    printf("v1[%d] = ", i);
    scanf("%d", &v1[i]);
  }  
  printf("Input v2:\n");
  for (i=0; i<N; i++) {
    printf("v2[%d] = ", i);
    scanf("%d", &v2[i]);
  }

  maxEqual = 0;
  for (i=0; i<N; i++) {
    /* compare the arrays by moving on v2 modulo N */
    numEqual = 0;
    for (idx1=0; idx1<N; idx1++) {
      idx2 = (i + idx1) % N;
      if (v1[idx1] == v2[idx2]) {
        numEqual++;
      }
    }

    /* if on maximum, save current rotation */
    if (numEqual > maxEqual) {
      maxEqual = numEqual;
      maxRotation = i;
    }
  }

  /* final output */
  printf("Number of equal elements = %d\n", maxEqual);
  if (maxEqual > 0) {
    printf("Rotation:\n");
    for (i=0; i<N; i++) {
      idx2 = (maxRotation + i) % N;
      printf("v2[%d] = %d\n", i, v2[idx2]);
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
