/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 06 - Esercizio 02 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N 10

int main(void)
{
  int i, v[N], d, left, right, found, sorted;

  /* input data */
  sorted = 1;
  printf("Input v (dim=%d):\n", N);
  for (i=0; i<N && sorted==1; i++) {
    printf("v[%d] = ", i);
    scanf("%d", &v[i]);
    if (i>0 && v[i]<=v[i-1]) {
      sorted = 0;
    }
  }
  if (sorted == 0) {
    printf("Non-sorted array; aborting ...\n");
  } else {
    printf("Number to search = ");
    scanf("%d", &d);

    /* search */
    found = 0;
    left = 0;
    right = N-1;
    while (left<=right && found==0) {
      i = (left+right)/2;
      if (d == v[i]) {
        found = 1;
      }
      if (d < v[i]) {
        right = i - 1;
      } else {
        left = i + 1;
      }
    }

    /* output result */
    if (found == 1) {
      printf("Number %d found in position %d.\n", d, i);    
    } else {
      printf("Number %d NOT found.\n", d);    
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
