/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 06 - Esercizio 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N     6
#define DEBUG 1

int main(void)
{
  int i, j, key, v[N];

  /* input array */
  printf("Initial array:\n");
  for (i=0; i<N; i++) {
    printf("v[%d] = ", i);
    scanf("%d", &v[i]);
  }

  /* sorting */
  for (i=1; i<N; i++) {
    key = v[i];
    j = i-1;
    while (j>=0 && key<v[j]) {
      v[j+1] = v[j];
      j--;
    }
    v[j+1] = key;

    if (DEBUG != 0) {
      /* debug printing: output array */
      printf("Loop %d: v = ", i);
      for (j=0; j<N; j++) {
        printf("%d ", v[j]);
      }
      printf("\n");
    }
  }

  /* print sorted array */
  printf("Sorted array:\n");
  for (i=0; i<N; i++) {
    printf("v[%d] = %d\n", i, v[i]);
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
