/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 06 - Esercizio 06 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N 5

int main(void)
{
  int v1[N], v2[N], v3[2*N];
  int i, j, k;

  /* input v1 */
  printf("Input v1 (sorted, %d elements):\n", N);
  for (k=0; k<N; k++) {
    printf("v1[%d] = ", k);
    scanf("%d", &v1[k]);
  }

  /* input v2 */
  printf("Input v2 (sorted, %d elements):\n", N);
  for (k=0; k<N; k++) {
    printf("v2[%d] = ", k);
    scanf("%d", &v2[k]);
  }

  /* merge */
  i = j = k = 0;
  while (i<N && j<N) {
    if (v1[i] < v2[j]) {
      v3[k++] = v1[i++];
    } else {
      v3[k++] = v2[j++];
    }
  }

  /* deal with v1 tail */
  while (i < N) {
    v3[k++] = v1[i++];
  }

  /* deal with v2 tail */
  while (j < N) {
    v3[k++] = v2[j++];
  }
      
  /* output v3 */
  printf("Resulting array - v3:\n");
  for (k=0; k<2*N; k++) {
    printf("v3[%d] = %d\n", k, v3[k]);
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
