/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 06 - Esercizio 10 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N      6
#define M      3
#define SIZE  10
#define DEBUG  1

int main(void)
{
  int i, j, k, power, val, v[N], sorted[N], count[SIZE];

  /* input array */
  printf("Initial array:\n");
  for (i=0; i<N; i++) {
    printf("v[%d] = ", i);
    scanf("%d", &v[i]);
  }

  /* sorting */
  for (power=1, k=1; k<=M; k++) {
    /* counting sort on digits */
    for (i=0; i<SIZE; i++) {
      count[i] = 0;
    }
    for (i=0; i<N; i++) {
      val = (v[i]%(power*10)) / power;
      count[val]++;
    }
    for (i=1; i<SIZE; i++) {
      count[i] += count[i-1];
    }
    for (i=N-1; i>=0; i--) {
      val = (v[i]%(power*10)) / power;
      sorted[--count[val]] = v[i];
    }

    /* prepare for next iteration */
    power = power*10;
    for (i=0; i<N; i++) {
      v[i] = sorted[i];
    }

    if (DEBUG != 0) {
      /* debug printing: output array */
      printf("Loop %d: ", k);
      for (j=0; j<N; j++) {
        printf("%d ", v[j]);
      }
      printf("\n");
    }
  }
   
  /* output sorted array */
  printf("Sorted array:\n");
  for (i=0; i<N; i++) {
    printf("v[%d] = %d\n", i, v[i]);
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
