/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 06 - Esercizio 11 - Soluzione 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N 10

int main(void)
{
  int i, j, x, y, z, v[N], goOn;

  /* initialize the connection array */
  for (i=0; i<N; i++) {
    v[i] = i;
  }

  /* input connections */
  do {
    goOn = 0;
    printf("Input connection: "); 
    scanf("%d-%d", &x, &y);

    goOn = (x>=0 && x<N && y>=0 && y<N && x!=y);
    if (goOn) {
      /* test for connectivity */
      for (i=x; i!=v[i]; i=v[i]) ;
      for (j=y; j!=v[j]; j=v[j]) ;
      if (i == j) {
        printf("Nodes %d and %d already connected.\n", x, y);
      } else {
        printf("Nodes %d and %d NOT connected, ", x, y);
        printf("new connection created.\n");

        v[j] = i;
      }
    }
  } while (goOn);

  /* output connection sets */
  do {
    goOn = 0;
    printf("Input node: "); 
    scanf("%d", &z);

    goOn = (z>=0 && z<N);
    if (goOn) {
      /* look for connected nodes */
      printf("Nodes connected with %d: ", z);
      for (x=z; x!=v[x]; x=v[x]) ;
      for (i=0; i<N; i++) {
        for (y=i; y!=v[y]; y=v[y]) ;
        if (y==x && i!=z) {
          printf("%d ", i);
        }
      }
      printf("\n");
    }
  } while (goOn);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
