/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 07 - Esercizio 08 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define DIM 10

int main(void)
{
  int matrix[DIM][DIM], visit[DIM][DIM];
  int i, j, num, row, column;
  int endCycle, endValue;

  /* input matrix and starting cell */
  printf("Input Matrix:\n");
  for (i=0; i<DIM; i++) {
    for (j=0; j<DIM; j++) {
      printf("Element [%d][%d] = ", i, j);
      scanf("%d", &matrix[i][j]);
      visit[i][j] = 0; /* init visit matrix */
    }
  }

  printf("Initial coordinates:\n");
  printf("row: ");
  scanf("%d", &row);
  printf("column: ");
  scanf("%d", &column);

  /* perform the moves */
  endCycle = endValue = 0;
  do {
    num = matrix[row][column];

    if (num<0 || num>99) {
      endValue = 1;
    } else {
      if (visit[row][column] != 0) {
        endCycle = 1;
      } else {
        i = num/10;
        j = num%10;
        printf("Element (%d,%d) -> n = %2d ", row, column, num);
        printf("-> new element (%d, %d)\n", i, j);

        visit[row][column] = 1;
        row = i;
        column = j;
      }
    }
  } while (endCycle==0 && endValue==0);

  /* output termination reason */
  if (endCycle == 1) {
    printf("Cycle detected.\n");
  } else {
    printf("Non valid element found (<0 or >99).\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
