/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 07 - Esercizio 09 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

int main(void)
{
  int N, x, y, count;

  printf("Insert N: ");
  scanf("%d", &N);

  /* initial position */
  x = y = 0;
  printf("(%d,%d) ", x, y);
  count = 1;

  while (x<N-1 || y<N-1) {
    /* right or down step */
    if (x < N-1) {
      x++;
    } else {
      y++;
    }
    printf("(%d,%d) ", x, y);
    if (++count >= N) {
      printf("\n");
      count = 0;
    }

    /* left-down diagonal */
    while (x>0 && y<N-1) {
      x--;
      y++;
      printf("(%d,%d) ", x, y);
      if (++count >= N) {
        printf("\n");
        count = 0;
      }
    }

    /* down or right step */
    if (y < N-1) {
      y++;
    } else {
      x++;
    }
    printf("(%d,%d) ", x, y);
    if (++count >= N) {
      printf("\n");
      count = 0;
    }

    /* right-up diagonal */
    while (x<N-1 && y>0) {
      x++;
      y--;
      printf("(%d,%d) ", x, y);
      if (++count >= N) {
        printf("\n");
        count = 0;
      }
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
