/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 07 - Esercizio 10 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define R 20
#define C 20

int main(void)
{
  int matrix[R][C];
  int nr, nc, n, r, c, i, j;

  /* input matrix size */
  do {
    printf("Input the matrix dimensions.\n");
    printf("Format: rowNum (1-%d) <space> columnNum (1-%d): ", R, C);
    scanf("%d %d", &nr, &nc);
    if (nr<1 || nr>R || nc<1 || nc>C) {
      printf("Wrong size!\n");
    }
  } while (nr<1 || nr>R || nc<1 || nc>C);

  /* input matrix */
  for (r=0; r<nr; r++) {
    for (c=0; c<nc; c++) {
      printf("Element [%d][%d]: ", r, c);
      scanf("%d", &matrix[r][c]);
    }
  }

  /* input the splitting value */
  printf("Value to find: ");
  scanf("%d", &n);

  /* core: search the splitting value */
  for (r=0; r<nr; r++) {
    for (c=0; c<nc; c++) {

      if (matrix[r][c] == n) {
        printf("Row = %d, Column = %d\n", r, c);

        /* print the at-most 4 sub-matrices */
        if (r>0 && c>0) {
          printf("Top-left sub-matrix:\n");
          for (i=0; i<r; i++) {
            for (j=0; j<c; j++) {
              printf("%d ", matrix[i][j]);
            }
            printf("\n");
          }
        }
        if (r>0 && nc-c-1>0) {
          printf("Top-right sub-matrix:\n");
          for (i=0; i<r; i++) {
            for (j=c+1; j<nc; j++) {
              printf("%d ", matrix[i][j]);
            }
            printf("\n");
          }
        }
        if (nr-r-1>0 && c>0) {
          printf("Bottom-left sub-matrix:\n");
          for (i=r+1; i<nr; i++) {
            for (j=0; j<c; j++) {
              printf("%d ", matrix[i][j]);
            }
            printf("\n");
          }
        }
        if (nr-r-1>0 && nc-c-1>0) {
          printf("Bottom-right sub-matrix:\n");
          for (i=r+1; i<nr; i++) {
            for (j=c+1; j<nc; j++) {
              printf("%d ", matrix[i][j]);
            }
            printf("\n");
          }
        }
      }
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
