/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 07 - Esercizio 11 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define MAX_DIM 10
#define TRUE     1
#define FALSE    0

int main(void)
{
  int m1[MAX_DIM][MAX_DIM];
  int m2[MAX_DIM][MAX_DIM];
  int m3[MAX_DIM][MAX_DIM];
  int r1, c1, r2, c2;
  int i, j, k, error;

  /* input first matrix */
  do {
    printf("Number of rows    Matrix 1: ");
    scanf("%d", &r1);
    printf("Number of columns Matrix 1: ");
    scanf("%d", &c1);

    error = FALSE;
    if (r1<0 || r1>MAX_DIM || c1<0 || c1>MAX_DIM) {
      printf("ERROR: maximum size %d x %d.\n", MAX_DIM, MAX_DIM);
      error = TRUE;
    }
  } while (error == TRUE);

  for (i=0; i<r1; i++) {
    for (j=0; j<c1; j++) {
      printf("  m1[%d,%d] = ", i, j);
      scanf("%d", &m1[i][j]);
    }
  }

  /* input second matrix */
  do {
    printf("Number of rows    Matrix 2: ");
    scanf("%d", &r2);
    printf("Number of columns Matrix 2: ");
    scanf("%d", &c2);

    error = FALSE;
    if (r2 != c1) {
      printf("ERROR: matrix not compatible with the previous one.\n");
      error = TRUE;
    } else if (c2<0 || c2>MAX_DIM) {
      printf("ERROR: maximum size %d x %d.\n", MAX_DIM, MAX_DIM);
      error = TRUE;
    }
  } while (error == TRUE);

  for (i=0; i<r2; i++) {
    for (j=0; j<c2; j++) {
      printf("  m2[%d,%d] = ", i, j);
      scanf("%d", &m2[i][j]);
    }
  }

  /* compute the product */
  for (i=0; i<r1; i++) {
    for (j=0; j<c2; j++) {
      m3[i][j] = 0;
      for (k=0; k<c1; k++) {
        m3[i][j] += m1[i][k] * m2[k][j];
      }
    }
  }

  /* print-out result */
  printf("Number of rows    of the Product Matrix: %d\n", r1);
  printf("Number of columns of the Product Matrix: %d\n", c2);
  for (i=0; i<r1; i++) {
    for (j=0; j<c2; j++) {
      printf("  m3[%d, %d] = %d\n", i, j, m3[i][j]);
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
