/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 07 - Esercizio 12 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N       6    /* number of organisms */
#define DNA    10    /* DNA length */
#define ALIVE   1
#define DEAD    0

int main(void)
{
  int likeNum, likeMax, friend1, friend2;
  int i, j, k, continueFlag;
  char population[N][DNA+1];
  
  /* input phase */
  for (i=0; i<N; i++) {
    printf("Organism %d: ", i);
    for (j=0; j<DNA; j++) {
      scanf("%c", &population[i][j]);
    }
    scanf("%*c"); /* remove the '\n' */
    population[i][DNA] = ALIVE; /* last char is DEAD or ALIVE */
  }

  /* evolution */
  do {
    continueFlag = DEAD;
    likeMax = 1;

    /* for each organism ... */
    for (i=0; i<N-1; i++) {
      /* ... if it is alive ... */
      if (population[i][DNA] == ALIVE) {

        /* ... compare it with all which follow ... */
        for (j=i+1; j<N; j++) {
          /* ... only if they are alive ... */
          if (population[j][DNA] == ALIVE) {

            /* ... and evaluate similarity char by char */
            likeNum = 0;
            for (k=0; k<DNA; k++) {
              if (population[i][k] == population[j][k]) {
                likeNum++;
              }
            }

            /* store most similar organisms to make them couple */ 
            if (likeNum >= likeMax) {
              continueFlag = ALIVE;
              likeMax = likeNum;
              friend1 = i;
              friend2 = j;
            }
          } /* end - if j is alive */
        } /* end - for j */
      } /* end - if i is alive */    
    } /* end - for i */

    /* when coupling is possible ... evolve */
    if (continueFlag == ALIVE) {
      printf("Coupling: %d - %d\n", friend1, friend2);  
      population[friend1][DNA] = population[friend2][DNA] = DEAD;
    }
    
  } while (continueFlag == ALIVE);
  
  /* print-out all alive organisms */
  printf("Alive organisms:\n");
  for (i=0; i<N; i++) {
    if (population[i][DNA] == ALIVE) {
      printf("Organism %d: ", i);
      for (j=0; j<DNA; j++) {
        printf("%c", population[i][j]);
      }
      printf("\n");
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
