/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 07 - Esercizio Proposto 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define MAX 10

int main(void)
{
  int n, m, min, matrix[MAX][MAX];
  int i, j, k, ii, jj, sum, found=0;

  /* input matrix */
  printf("Matrix rows: ");
  scanf("%d", &n);
  printf("Matrix columns: ");
  scanf("%d", &m);
  for (i=0; i<n; i++) {
    for (j=0; j<m; j++) { 
      printf("Element [%d, %d]: ", i, j);
      scanf("%d", &matrix[i][j]);
    }
  }

  /* computation and output */
  min = m > n ? n : m;
  for (k=2; (k<=min) && !found; k++) {
    for (i=0; (i<=n-k) && !found; i++) {
      for (j=0; (j<=m-k) && !found; j++) {
        sum = 0;
        for (ii=i; ii<i+k; ii++) {
          for (jj=j; jj<j+k; jj++) {
            sum += matrix[ii][jj];
          }
        }
        if (sum == 0) {
          printf("Found sub-matrix starting at ");
          printf("[%d, %d], dimension %d\n", i, j, k);
          found = 1;
        }
      }
    }
  }

  if (!found) {
    printf("No sub-matrix found.\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
