/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 07 - Esercizio Proposto 05 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define  DIM       3

int main(void)
{
  int i, j, k, equal, valid, move, player=1, win=0;
  char board[DIM][DIM];

  printf("Tic Tac Toe Game\n");

  /* initialize and print the board */
  for (i=0; i<DIM; i++) {
    printf("   ");
    for (j=0; j<DIM; j++) {
      board[i][j] = i*DIM + j + '1';
      printf("%c", board[i][j]);
    }
    printf("\n");
  }

  for (k=0; k<DIM*DIM && !win; k++) {
    /* get a move */
    player = 1-player;
    valid = 0;
    do {
      printf("Player %d, make your move: ", player+1);
      scanf("%d", &move);
      if (move<1 || move>9) {
        printf("Not a valid move!\n");
      } else {
        move--;
        if (board[move/DIM][move%DIM] != move+'1') {
          printf("Not a valid move!\n");
        } else {
          valid = 1;
        }
      }
    } while (valid == 0);

    /* update and print the board */
    board[move/DIM][move%DIM] = (player==0) ? 'X' : 'O';
    for (i=0; i<DIM; i++) {
      printf("   ");
      for (j=0; j<DIM; j++) {
        printf("%c", board[i][j]);
      }
      printf("\n");
    }

    /* check for victory: rows */
    for (i=0; i<DIM && !win; i++) {
      equal = 1;
      for (j=1; j<DIM && equal; j++) {
        if (board[i][j] != board[i][j-1]) {
          equal = 0;
        }
      }
      if (equal != 0) {
        printf("Player %d, you WON!\n", player+1);
        win = 1;
      }
    }
    /* check for victory: columns */
    for (j=0; j<DIM && !win; j++) {
      equal = 1;
      for (i=1; i<DIM && equal; i++) {
        if (board[i][j] != board[i-1][j]) {
          equal = 0;
        }
      }
      if (equal != 0) {
        printf("Player %d, you WON!\n", player+1);
        win = 1;
      }
    }
    /* check for victory: diagonal */
    if (!win) {
      equal = 1;
      for (i=j=1; i<DIM && equal; i++, j++) {
        if (board[i][j] != board[i-1][j-1]) {
          equal = 0;
        }
      }
      if (equal != 0) {
        printf("Player %d, you WON!\n", player+1);
        win = 1;
      }
    }
    /* check for victory: anti-diagonal */
    if (!win) {
      equal = 1;
      for (i=DIM-2, j=1; j<DIM && equal; i--, j++) {
        if (board[i][j] != board[i+1][j-1]) {
          equal = 0;
        }
      }
      if (equal != 0) {
        printf("Player %d, you WON!\n", player+1);
        win = 1;
      }
    }
  }

  if (win == 0) {
    printf("Draw game!\n\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
