/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio 02 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

/* function prototypes */
int factor1(int n);
void factor2(int n, int *fatt);

/*
 *  main program
 */
int main(void)
{
  int n, val;

  printf("Number (int, >= 0): ");
  scanf("%d", &n);

  if (n >= 0) {
    printf("Factor1: %d! = %d\n", n, factor1(n));
    factor2(n, &val);
    printf("Factor2: %d! = %d\n", n, val);
  } else {
    printf("The number %d is negative.\n", n);
  }
  return 0;
}

/*
 *  factorial computation: solution 1
 */
int factor1(int n)
{
  int val, i;

  val = 1;
  for (i=n; i>1; i--) {
    val *= i;
  }
  return val;
}

/*
 *  factorial computation: solution 2
 */
void factor2(int n, int *fatt)
{
  *fatt = 1;
  while (n > 1) {
    *fatt *= n;
    n--;
  }
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
