/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <math.h>

#define   N   10

/* function prototypes  */
void readArray(float array[]);
float average(float array[]);
float standardDeviation(float x_mean, float array[]);

/*
 *  main program
 */
int main(void)
{
  float array[N], x_mean, sigma;

  readArray(array);
  x_mean = average(array);
  sigma = standardDeviation(x_mean, array);
  printf("Standard deviation = %f.\n", sigma);
  return 0;
}

/*
 *  read the input values
 */
void readArray(float array[])
{
  int i;

  for (i=0; i<N; i++) {
    printf("Value [%d]: ", i); 
    scanf("%f", &array[i]);
  }
}

/*
 *  average value computation 
 */
float average(float array[])
{
  int i;
  float x_mean=0;

  for (i=0; i<N; i++) {
    x_mean += array[i];
  }
  return x_mean/N;
}

/*
 *  standard deviation computation
 */
float standardDeviation(float x_mean, float array[])
{
  int i;
  float sigma=0;

  /* sum of all the squares */
  for (i=0; i<N; i++) {
     sigma += pow(x_mean-array[i], 2);
  }
  sigma /= N;
  return sqrt(sigma);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
