/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio 05 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <math.h>

#define  MAX   16

/* function prototypes */
int readNumber(char []);
int msToDecimal(char [], int);
int c1ToDecimal(char [], int);
int c2ToDecimal(char [], int);

/*
 *  main program
 */
int main(void)
{
  int dim;
  char array[MAX+1];

  dim = readNumber(array);
  printf("MS value: %d\n", msToDecimal(array, dim));
  printf("C1 value: %d\n", c1ToDecimal(array, dim));
  printf("C2 value: %d\n", c2ToDecimal(array, dim));
  return 0;
}

/*
 *  read a binary number and store it into an array
 */
int readNumber(char array[])
{
  int i=0;

  printf("Binary number: ");
  do {
    scanf("%c", &array[i]);
    i++;
  } while (array[i-1]=='0' || array[i-1]=='1');

  return i-1;
}

/*
 *  module-and-sign conversion
 */
int msToDecimal(char array[], int dim)
{
  int i, val=0;

  for (i=1; i<dim; i++) {
    val = (val << 1) + (array[i] - '0');
  }
  if (array[0] == '1') {
    val = -val;
  }
  return val;
}

/*
 *  one-complement conversion
 */
int c1ToDecimal(char array[], int dim)
{
  int i, val=0;

  for (i=0; i<dim; i++) {
    val = (val << 1) + (array[i] - '0');
  }
  if (array[0] == '1') {
    val = val - pow(2, dim) + 1;
  }
  return val;
}

/*
 *  two-complement conversion
 */
int c2ToDecimal(char array[], int dim)
{
  int i, val=0;

  for (i=0; i<dim; i++) {
    val = (val << 1) + (array[i] - '0');
  }
  if (array[0] == '1') {
    val = val - pow(2, dim);
  }
  return val;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
