/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio 06 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

/* function prototypes */
int readMatrix(float [3][3]);
float d2x2(float [3][3]);
float d3x3(float [3][3]);
float delta(float [3][3], int);

/*
 *  main program
 */
int main(void)
{
  int dim;
  float matrix[3][3];

  dim = readMatrix(matrix);
  printf("Determinant = %.3f.\n", delta(matrix, dim));
  return 0;
}

/*
 *  read in the matrix; return the matrix size
 */
int readMatrix(float matrix[3][3])
{
  int i, j, dim;

  do {
    printf("Matrix size (2 or 3): "); 
    scanf("%d", &dim);
  } while (dim!=2 && dim!=3);

  for (i=0; i<dim; i++) {
    for (j=0; j<dim; j++) {
      printf("Element [%d, %d]: ", i, j); 
      scanf("%f", &matrix[i][j]);
    }
  }
  return dim;
}

/*
 *  determinant computation
 */
float delta(float matrix[3][3], int dim)
{
  float d;

  if (dim == 2) {
    d = d2x2(matrix);
  } else {
    d = d3x3(matrix);
  }
  return d;
}

/*
 *  matrix 2x2 determinant 
 */
float d2x2(float matrix[3][3])
{
  float d;

  d = matrix[0][0]*matrix[1][1] - matrix[1][0]*matrix[0][1];
  return d;
}

/*
 *  matrix 3x3 determinant  
 */
float d3x3(float matrix[3][3])
{
  float aux[3][3], d;

  aux[0][0] = matrix[1][1];
  aux[0][1] = matrix[1][2];
  aux[1][0] = matrix[2][1];
  aux[1][1] = matrix[2][2];
  d = matrix[0][0] * d2x2(aux);

  aux[0][0] = matrix[1][0];
  aux[0][1] = matrix[1][2];
  aux[1][0] = matrix[2][0];
  aux[1][1] = matrix[2][2];
  d -= matrix[0][1] * d2x2(aux);

  aux[0][0] = matrix[1][0];
  aux[0][1] = matrix[1][1];
  aux[1][0] = matrix[2][0];
  aux[1][1] = matrix[2][1];
  d += matrix[0][2] * d2x2(aux);

  return d;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
