/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio 07 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define R 20
#define C 20

/* function prototypes */
void printAll(int [R][C], int, int, int, int);
void printOne(int [R][C], int, int, int, int);

/*
 *  main program
 */
int main(void)
{
  int matrix[R][C];
  int nr, nc, val, r, c;

  /* input matrix size */
  do {
    printf("Input the matrix dimensions.\n");
    printf("Format: rowNum (1-%d) <space> columnNum (1-%d): ", R, C);
    scanf("%d %d", &nr, &nc);
    if (nr<1 || nr>R || nc<1 || nc>C) {
      printf("Wrong size!\n");
    }
  } while (nr<1 || nr>R || nc<1 || nc>C);

  /* input matrix elements */
  for (r=0; r<nr; r++) {
    for (c=0; c<nc; c++) {
      printf("Element [%d][%d]: ", r, c);
      scanf("%d", &matrix[r][c]);
    }
  }
  /* input the splitting value */
  printf("Value to find: ");
  scanf("%d", &val);

  /* core section: search the splitting value and print sub-matrices */
  for (r=0; r<nr; r++) {
    for (c=0; c<nc; c++) {
      if (matrix[r][c] == val) {
        printf("Row = %d - Column = %d\n", r, c);
        printAll(matrix, nr, nc, r, c);
      }
    }
  }
  return 0;
}

/* 
 *  print-out all sub-matrices
 */
void printAll(int matrix[R][C], int nr, int nc, int r, int c)
{
  if (r>0 && c>0) {
    printf("Top-left sub-matrix:\n");
    printOne(matrix, 0, r-1, 0, c-1);
  }
  if (r>0 && c<nc-1) {
    printf("Top-right sub-matrix:\n");
    printOne(matrix, 0, r-1, c+1, nc-1);
  }
  if (r<nr-1 && c>0) {
    printf("Bottom-left sub-matrix:\n");
    printOne(matrix, r+1, nr-1, 0, c-1);
  }
  if (r<nr-1 && c<nc-1) {
    printf("Bottom-right sub-matrix:\n");
    printOne(matrix, r+1, nr-1, c+1, nc-1);
  }
}

/* 
 *  print-out one sub-matrix
 */
void printOne(int matrix[R][C], int r1, int r2, int c1, int c2)
{
  int r, c;

  for (r=r1; r<=r2; r++) {
    for (c=c1; c<=c2; c++) {
      printf("%d ", matrix[r][c]);
    }
    printf("\n");
  }
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
