/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio 09 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define  MAX   100

/* function prototypes */
void readNumber(int v[]);
void sumNumbers(int v1[], int v2[], int vr[]);
void printResult(int v[]);

/*
 *  main program
 */
int main(void)
{
  int v1[MAX], v2[MAX], vr[MAX+1];

  readNumber(v1);
  readNumber(v2);
  sumNumbers(v1, v2, vr);
  printResult(vr);
  return 0;
}

/*
 *  read an extended number
 */
void readNumber(int v[])
{
  int i=0, l;
  char cn[100];

  printf("Introduce a number: ");
  do {
    scanf("%c", &cn[i]);
  } while (cn[i++] != '\n');

  l = i-1;
  for (i=0; i<l; i++) {
    v[i] = cn[l-1-i] - '0'; 
  }
  for (i=l; i<MAX; i++) {
    v[i] = 0; 
  }
}

/*
 *  sum two extended numbers
 */
void sumNumbers(int v1[], int v2[], int vr[])
{
  int i, sum, carry=0;

  for (i=0; i<MAX; i++) {
    sum = v1[i] + v2[i] + carry;
    vr[i] = sum % 10;
    carry = sum / 10;
  }
  vr[MAX] = carry;
}

/*
 *  output result
 */
void printResult(int v[])
{
  int i=MAX, flag=0;

  printf("Sum = ");
  for ( ; i>=0 && v[i]==0; i--) ;
  for ( ; i>=0; i--) {
    printf("%d", v[i]);
    flag = 1;
  }
  if (flag == 0) {
    printf("0");
  }
  printf("\n");
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
