/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio Proposto 01 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define DIM 100

/* function prototypes */
int readArray(int array[]);
void findSubArray(int v1[], int d1, int v2[], int d2);

/*
 *  main program
 */
int main(void)
{
  int v1[DIM], v2[DIM];
  int dim1, dim2;

  printf("First  array\n");
  dim1 = readArray(v1);
  printf("Second array\n");
  dim2 = readArray(v2);

  if (dim1 < dim2) {
    printf("Searching the first array into the second:\n");
    findSubArray(v1, dim1, v2, dim2);
  } else {
    printf("Searching the second array into the first:\n");
    findSubArray(v2, dim2, v1, dim1);
  }

  return 0;
}

/*
 *  load an array, return its size
 */
int readArray(int array[])
{
  int i, dim;

  do {
    printf("  Size: ");
    scanf("%d", &dim);
  } while (dim<=0 || dim>DIM);

  for (i=0; i<dim; i++) {
    printf("  Value[%d] = ", i);
    scanf("%d", &array[i]);
  }

  return dim;
}

/*
 *  find all occurrences of the first array into the second one
 */
void findSubArray(int v1[], int d1, int v2[], int d2)
{
  int i1, i2, flag, found=0;

  for (i2=0; i2<=d2-d1; i2++) {
    flag = 1;
    for (i1=0; i1<d1 && flag==1; i1++) {
      if (v1[i1] != v2[i1+i2]) {
        flag = 0;
      }
    }

    if (flag == 1) {
      printf("  Sub-array found from index %d.\n", i2);
      found = 1;
    }
  }
  if (!found) {
    printf("  No sub-array found.\n");  
  }
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
