/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio Proposto 02 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h> 
#include <stdlib.h> 

#define  MAX  10 

/* function prototypes */
int readNumber(void); 
void readArray(float array[], int n); 
void product(float v1[], float v2[], int n1, int n2); 
    
/*
 *  main program
 */
int main(void) 
{ 
  float v1[MAX], v2[MAX]; 
  int n1, n2; 
     
  n1 = readNumber(); 
  n2 = readNumber(); 

  readArray(v1, n1); 
  readArray(v2, n2); 
  product(v1, v2, n1, n2); 

  return EXIT_SUCCESS;
} 
      
/*
 *  read an integer number
 */
int readNumber(void) 
{
  int n;

  printf("Number of elements (1-%d): ", MAX); 
  scanf("%d", &n);
       
  if (n<=0 || n>MAX) {
    printf("Value out of bounds, aborting ...\n");
    exit(EXIT_FAILURE); 
  }

  return n;
} 
       
/*
 *  read an array of floats
 */
void readArray(float array[], int n) 
{ 
  int i; 
    
  for (i=0; i<n; i++) { 
    printf("Array[%d] = ", i); 
    scanf("%f", &array[i]); 
  } 
}

/*
 *  display the product of two arrays
 */
void product(float v1[], float v2[], int n1, int n2)
{ 
  int i, j;

  for (i=0; i<n1; i++) { 
    for (j=0; j<n2; j++) { 
      printf("%7.2f", v1[i]*v2[j]); 
    }
    printf("\n"); 
  } 
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
