/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 08 - Esercizio Proposto 03 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#define N_V        5  /* number of arrays */
#define N_E        3  /* number of elements for each array */
#define N    N_V*N_E  /* total number of elements */

/* function prototypes */
int findMin(int [N_V][N_E], int [N_V]);

/*
 *  main program
 */
int main(void)
{
  int i, j, matrix[N_V][N_E], indices[N_V], array[N];
  
  /* read all arrays */
  for (i=0; i<N_V; i++) {
    printf("Array %d (sorted):\n", i);
    for (j=0; j<N_E; j++) {
      printf("  array%d[%d] = ", i, j);
      scanf("%d", &matrix[i][j]);
      if (j > 0) {
        if (matrix[i][j] < matrix[i][j-1]) {
          printf("Array not sorted!\n");
          /* stop execution */
          return EXIT_FAILURE; 
        }
      }
    }
    /* initialize the "indices" array */
    indices[i] = 0;
  }
  
  /* merge */
  j = 0;
  do {
    i = findMin(matrix, indices);
    if (i >= 0) {
      array[j++] = matrix[i][indices[i]++];
    }
  } while (i >= 0);

  /* print-out resulting array */
  printf("Resulting array:\n");
  for (i=0; i<N; i++) {
    printf("%d ", array[i]);
  }
  printf("\n");
  return EXIT_SUCCESS;
}

/* 
 *  find-out minimum on all arrays
 */
int findMin(int matrix[N_V][N_E], int indices[N_V])
{
  int i, min, minIndex=-1;
  
  for (i=0; i<N_V; i++) {
    if (indices[i] < N_E) {
      if (minIndex==-1 || matrix[i][indices[i]]<min) {
        minIndex = i;
        min = matrix[i][indices[i]];
      }
    }
  }
  return minIndex;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
