/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 09 - Esercizio 06 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>

#define DIM 16
#define NUM 20

/* function prototypes */
int sort(char [][DIM], int);
void swap(char [][DIM], int, int);

/*
 *  main program
 */
int main(void)
{
  int i, nSwaps, n;
  char tmpArray[DIM], strArray[NUM][DIM]; 
 
  /* read the words */
  n = 0;
  do {
    printf("Word %2d: ", n+1);
    scanf("%s", tmpArray);
    if (strcmp(tmpArray, "stop") != 0) {
      strcpy (strArray[n++], tmpArray);
    } 
  } while (n<NUM && strcmp(tmpArray, "stop") != 0);

  /* sort the words; check for the number of swaps */
  nSwaps = sort(strArray, n);
  if (nSwaps == 0){
    printf("Words already sorted!\n");
  } else {
    /* display the result */
    printf("Sorted words:\n");
    for (i=0; i<n; i++) {
      printf("Word %d: %s\n", i+1, strArray[i]);
    }
  }

  return 0;
}

/*
 *  selection sort on words; return the number of swaps performed
 */
int sort(char strArray[NUM][DIM], int n)
{
  int i, j, nSwaps=0, posMin;

  for (i=0; i<n-1; i++) {
    posMin = i; 
    for (j=i+1; j<n; j++) {
      if (strcmp(strArray[posMin], strArray[j]) > 0) {
        posMin = j;
      }
    }
    if (posMin != i) {
      swap(strArray, posMin, i);
      nSwaps++;
    }
  }

  return nSwaps;
}

/*
 *  swap two strings in the string array
 */
void swap(char strArray[NUM][DIM], int i, int j)
{
  char buf[DIM];
  
  strcpy(buf, strArray[i]);
  strcpy(strArray[i], strArray[j]);
  strcpy(strArray[j], buf);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
