/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 09 - Esercizio 09 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAX 101

int main(void)
{
  char string[MAX];
  int i, j, flag;

  /* input string */
  printf("Input string: ");
  i = 0;
  do {
    scanf("%c", &string[i]);
  } while (string[i++] != '\n');
  string[i-1] = '\0'; /* remove the \n */

  /* computation */
  flag = 1;
  i = 0;
  j = strlen(string) - 1;
  while (i<j && flag==1) {
    while (i<j && string[i]==' ') {
      i++;
    }
    while (j>i && string[j]==' ') {
      j--;
    }
    if (tolower(string[i]) != tolower(string[j])) {
      flag = 0;
    } else {
      i++; 
      j--;
    }
  }

  /* output result */
  if (flag) {
    printf("The string is palindrome.\n");
  } else {
    printf("The string is NOT palindrome.\n");
  }
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
