/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 09 - Esercizio 12 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>

#define LENGTH 20+1

/* function prototypes */
void alternate(char s1[LENGTH], char s2[LENGTH], int n);
void printOneChar(char str[LENGTH], int i, int l);

/*
 *  main program
 */
int main(void)
{
  char s1[LENGTH], s2[LENGTH];
  int n;

  /* data input */
  printf("First string: ");
  scanf("%s", s1);
  printf("Second string: ");
  scanf("%s", s2);
  printf("Start with string (1 or 2): ");
  scanf("%d", &n);

  /* alternated print */
  alternate(s1, s2, n);
  return 0;
}

/*
 *  print the chars from two strings in an alternated fashion
 */
void alternate(char s1[LENGTH], char s2[LENGTH], int n)
{
  int i, l1, l2;

  l1 = strlen(s1);
  l2 = strlen(s2);

  for (i=0; (i<l1) || (i<l2); i++) {
    if (n == 1) {
      printOneChar(s1, i, l1);
      printOneChar(s2, i, l2);
    } else {
      printOneChar(s2, i, l2);
      printOneChar(s1, i, l1);
    }
  }
  printf("\n");
}

/*
 *  display a char (if it exists)
 */
void printOneChar(char str[LENGTH], int i, int l)
{
  if (i < l) {
    printf("%c", str[i]);
  }
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
