/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 09 - Esercizio 13 - Soluzione 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAX 501

/*
 *  check whether the input char is a vocal
 */
int isvocal(char ch)
{
  char c = tolower(ch);

  return ((c=='a') || (c=='e') || (c=='i') || (c=='o') || (c=='u'));
}

/*
 *  encoding/decoding function
 */
void code(char *message, int dir)
{
  char *old, *new, save;
  int length=strlen(message);

  /* save the last/first vocal */
  old = message + ((dir == 1) ? 0 : length-1);
  while (old>=message && old<message+length && !isvocal(*old)) {
    old += dir;
  }
  save = *old;

  /* right/left shift all previous/next vocals */
  new = old + dir;
  while (new>=message && new<message+length) {
    while (new>=message && new<message+length && !isvocal(*new)) {
      new += dir;
    }
    if (new>=message && new<message+length) {
      *old = *new;
      old = new;
      new += dir;
    }
  }

  /* replace the first/last vocal */
  *old = save;
}

/*
 *  main program
 */
int main(void)
{
  char message[MAX], cmd;
  int i=0, dir;

  /* input phase */
  printf("Insert the string: ");
  do {
    scanf("%c", &message[i]);
  } while (message[i++] != '\n');
  message[i-1] = '\0';

  printf("Encode (E) or Decode (D)? ");
  scanf("%c", &cmd);

  /* computation and output */
  dir = (toupper(cmd) == 'E') ? -1 : 1;
  code(message, dir);
  printf("%s message is: %s\n", (dir == 1) ? "Decoded" : "Encoded", message);
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
