/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 09 - Esercizio Proposto 02 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAX 31

int main(int argc, char *argv[])
{
  int i, count, maxCount;
  char word[MAX];

  if (argc != 2) {
    printf("Parameter error.\n");
    printf("Run program as: %s <string>\n", argv[0]);
    return 1;
  }
  strcpy(word, argv[1]);

  count = 0; 
  maxCount = 0;
  for (i=0; i<strlen(word); i++) {
    if (isdigit(word[i])) {
      count++;
    } else {
      if (count > maxCount) {
        maxCount = count;
      }
      count = 0;
    }
  }

  printf("The longest digit sequence is %d char(s) long.\n", maxCount);
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
