/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 09 - Esercizio Proposto 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAX 102  /* 100 + \n + \0 */

int main(void)
{
  int i, end;
  char sentence[MAX];

  do {
    /* input phase */
    printf("Insert a sentence: ");
    i = 0;
    do {
      scanf("%c", &sentence[i]);
    } while (sentence[i++] != '\n');
    sentence[i] = '\0';
    end = !strcmp(sentence, "stop\n");

    if (!end) {
      /* output phase */
      for (i=0; i<strlen(sentence); i++) {
        printf("%c", sentence[i]);

        switch (toupper(sentence[i])) {
          case 'A':
          case 'E':
          case 'I':
          case 'O':
          case 'U': if (isalpha(sentence[i+1])) {
                      printf("-");
                    }
        }
      }
    }
  } while (!end);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
