/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 09 - Esercizio Proposto 05 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAX_LENGTH   20+1
#define LOOSE_ERRORS    5

int main(void)
{
  char key[MAX_LENGTH], current[MAX_LENGTH], trial;
  int i, num_errors=0, num_to_guess;

  /* variables initialization */
  printf("Player 1, insert the solution word: ");
  scanf("%s%*c", key);

  for (i=0; i<strlen(key); i++) {
    key[i] = toupper(key[i]);
    current[i] = '_';
  }
  current[i] = '\0';
  num_to_guess = strlen(key);

  /* game */
  printf("Player 2, start trying (you loose making %d errors).\n", LOOSE_ERRORS);
  do {
    printf("The word is %s\n", current);
    printf("Trial? ");
    scanf("%c%*c", &trial);
    trial = toupper(trial);
    if (strchr(key, trial)==NULL || strchr(current, trial)!=NULL) {
      printf("Error! ");
      if (++num_errors < LOOSE_ERRORS) {
        printf("You loose making %d more error(s).", LOOSE_ERRORS-num_errors);
      }
      printf("\n");
    } else {
      printf("Correct guess!\n");
      for (i=0; i<strlen(key); i++) {
        if (key[i] == trial) {
          current[i] = trial;
          num_to_guess--;
        }
      }
    }
  } while ((num_to_guess>0) && (num_errors<LOOSE_ERRORS));

  /* game result */
  printf("The word was %s, ", key);
  printf("you %s.\n", num_errors>=LOOSE_ERRORS ? "lost" : "won");

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
