/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio 03 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>

#define LENGTH 60+1    /* 60 + \n */

int main(int argc, char *argv[])
{
  int i, j, num_separator, num_total, num_each, num_other;
  char line[LENGTH+1];
  FILE *fin, *fout;

  if (argc < 3) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <input_file> <output_file>.\n", argv[0]);
    return 1;
  }

  fin = fopen(argv[1], "r");
  fout = fopen(argv[2], "w");
  if (fin==NULL || fout==NULL) {
    printf("Error opening the file(s).\n");
    return 1;
  }

  while (fgets(line, LENGTH+1, fin) != NULL) {
    num_separator = 0;
    for (i=0; i<strlen(line); i++) {
      if (line[i] == ' ') {
        num_separator++;
      }
    }
    num_total = LENGTH - strlen(line);
    num_each = num_total / num_separator;
    num_other = num_total % num_separator;

    for (i=0; i<strlen(line); i++) {
      fprintf(fout, "%c", line[i]);
      if (line[i] == ' ') {
        for (j=0; j<num_each; j++) {
          fprintf(fout, " ");
        }
        if (num_other > 0) {
          fprintf(fout, " ");
          num_other--;
        }
      }
    }
  }
  fclose(fin);
  fclose(fout);
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
