/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

/* constants */
#define NAME_LENGTH   20
#define LINE_LENGTH  121

enum {
  ROW,
  CHAR,
  DIGIT,
  CAPITAL,
  SMALL,
  SPACE,
  PUNCT,
  OTHER,
  INFO_SIZE
};

int main(void)
{
  char name[NAME_LENGTH], line[LINE_LENGTH], *punct=".,;:?!";
  int info[INFO_SIZE], i;
  FILE *fp;

  /* get the file name and open the file */
  printf("Input file name: ");
  scanf("%s", name);
  fp = fopen (name, "r");
  if (fp == NULL) {
    printf("Error opening the input file.\n");
    return 1;
  }

  for (i=0; i<INFO_SIZE; i++) {
    info[i] = 0;
  }

  /* read the file */
  while (fgets(line, LINE_LENGTH, fp) != NULL) {
    info[ROW]++;
    info[CHAR] += strlen(line);
    for (i=0; i<strlen(line); i++) {
      if (isdigit(line[i])) {
        info[DIGIT]++;
      } else if (isupper(line[i])) {
        info[CAPITAL]++;
      } else if (islower(line[i])) {
        info[SMALL]++;
      } else if (isspace(line[i])) {
        info[SPACE]++;
      } else if (strchr(punct, line[i]) != NULL) {
        info[PUNCT]++;
      } else {
        info[OTHER]++;
      }
    }
  }
  fclose(fp);

  /* display results */
  printf("# Row               : %d\n", info[ROW]);
  printf("# Char              : %d\n", info[CHAR]);
  printf("# Digit             : %d\n", info[DIGIT]);
  printf("# Capital letters   : %d\n", info[CAPITAL]);
  printf("# Small letters     : %d\n", info[SMALL]);
  printf("# Space symbols     : %d\n", info[SPACE]);
  printf("# Punctuation marks : %d\n", info[PUNCT]);
  printf("# Unrecognized chars: %d\n", info[OTHER]);
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
