/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio 05 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>

#define MAX_NAME    20+1

int main(int argc, char *argv[])
{
  char fileName[MAX_NAME], bestName[MAX_NAME], currName[MAX_NAME];
  int min, max, i, val, bestVal, currVal, totVal;
  FILE *fp;

  if (argc < 4) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <linea> <min> <max>\n", argv[0]);
    return 1;
  }
  sscanf(argv[2], "%d", &min);
  sscanf(argv[3], "%d", &max);

  totVal = bestVal = 0;
  bestName[0] = '\0';
  for (i=min; i<=max; i++) {
    sprintf(fileName, "%s%d.txt", argv[1], i);
    fp = fopen(fileName, "r");
    if (fp == NULL) {
      printf("Error opening the file %s\n", fileName);
    } else {
      /* parse the file */
      fscanf(fp, "%s", currName);
      currVal = 0;
      while (fscanf(fp, "%d", &val) != EOF) {
        currVal += val;
      }
      fclose(fp);

      totVal += currVal;
      if (strlen(bestName)==0 || currVal>bestVal) {
        bestVal = currVal;
        strcpy(bestName, currName);
      }
    }
  }

  /* output results */
  printf("Total value: %d\n", totVal);
  printf("Best product: %s (value = %d)\n\n", bestName, bestVal);
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
