/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio 06 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <math.h>

#define LENGTH     30
#define DEGREE     20

int main(int argc, char *argv[])
{
  int poly[DEGREE];
  int i, c, e, x1, x2, valid;
  float x, delta, y;
  FILE *fp;

  if (argc < 2) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <input_file>.\n", argv[0]);
    return 1;
  }
  fp = fopen(argv[1], "r");
  if (fp == NULL) {
    printf("Error opening the file.\n");
    return 1;
  }
  
  for (i=0; i<DEGREE; i++) {
    poly[i] = 0;
  }

  /* parse the file */
  while (fscanf(fp, "%d %d", &c, &e) != EOF) {
    if (e<0 || e>=DEGREE) {
      printf("Invalid exponent.\n");
      fclose(fp);
      return 1;
    }
    poly[e] += c;
  }
  fclose(fp);
  
  /* data input from the keyboard */
  valid = 0;
  do {
    printf("Input x1, x2, Deltax (format: x1#x2#Deltax): ");
    scanf("%d#%d#%f", &x1, &x2, &delta);

    if (x1>0 && x2>0 && x1<=x2 && delta>0) {
      valid = 1;
    } else {
      printf("Error reading the parameters.\n");
    }
  } while (!valid);

  /* computation */
  for (x=x1; x<=x2; x+=delta) {
    y = 0;
    for (i=0; i<DEGREE; i++) {
      y += poly[i] * pow(x, i); 
    }
    printf("x = %.1f   y = f(x) = %.3f\n", x, y);
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
