/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio 08 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define MAX_WORD 20+1

/* function prototypes */
int compare(char *, char *);

/*
 *  main program
 */ 
int main(int argc, char *argv[])
{
  FILE *fin, *fout;
  char c, strRead[MAX_WORD], strIn[MAX_WORD], strOut[MAX_WORD];
  int i;

  /* check command line */
  if (argc < 3) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <inputFile> <outputFile>\n", argv[0]);
    return 1;
  }

  /* open files */
  fin = fopen(argv[1], "r");
  fout = fopen(argv[2], "w");
  if (fin==NULL || fout==NULL) {
    printf("Error while opening the files.\n");
    return 1;
  }

  /* get the words to process */
  printf("Input the word to search: ");
  scanf("%s", strIn);
  printf("Input the word to replace: ");
  scanf("%s", strOut);

  /* computation */
  i = 0;
  while (fscanf(fin, "%c", &c) != EOF) {

    if (isalpha(c) || isdigit(c)) {
      /* put the char in the string */
      strRead[i] = c;
      i++;
    } else {
      /* separator sign: possibly replace the string */
      strRead[i] = '\0';      
      if (compare(strRead, strIn)) {
        fprintf(fout, "%s", strOut);
      } else {
        fprintf(fout, "%s", strRead);
      }
      fprintf(fout, "%c", c);
      i = 0;
    }
  }
  fclose(fin);
  fclose(fout);
  return 0;
}

/* 
 *  case insensitive comparison between two strings
 *  return 1 if the strings are equal, 0 otherwise
 */
int compare(char *str1, char *str2)
{
  int i=0, equal=1;

  if (strlen(str1) != strlen(str2)) {
    return 0;
  }

  while (i<strlen(str1) && equal==1) {
    if (toupper(str1[i]) != toupper(str2[i])) {
      equal = 0;
    }
    i++;
  }

  return equal;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
