/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio Proposto 01 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>

#define NUM    30
#define SIZE   21

/* function prototypes */
void sort(char strArray[NUM][SIZE], int n);

/*
 *  main program
 */
int main(int argc, char *argv[])
{
  char word[SIZE], strArray[NUM][SIZE];
  FILE *fin, *fout;
  int n, i;

  if (argc < 3) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <input_file> <output_file>.\n", argv[0]);
    return 1;
  }

  /* input phase */
  fin = fopen(argv[1], "r");
  if (fin == NULL) { 
    printf("Error opening the input file.\n");
    return 1;
  }

  n = 0;
  while (fscanf(fin, "%s", word)!=EOF && n<NUM) {
    strcpy(strArray[n++], word);
  }
  fclose(fin);

  /* sort strings */
  sort(strArray, n);  

  /* output phase */
  fout = fopen(argv[2], "w");
  if (fout == NULL) {
    printf("Error opening the output file.\n");
    return 1;
  }

  for (i=0; i<n; i++) {
    fprintf(fout, "%s\n", strArray[i]);
  }
  fclose(fout);
  return 0;
}

/*
 *  bubble sort on strings
 */
void sort(char strArray[NUM][SIZE], int n)
{
  char temp[SIZE];
  int i, j;

  for (i=0; i<n-1; i++) {
    for (j=0; j<n-1-i; j++) {
      if (strcmp(strArray[j], strArray[j+1]) > 0) {          
        strcpy(temp, strArray[j]);
        strcpy(strArray[j], strArray[j+1]);
        strcpy(strArray[j+1], temp);
      }
    }
  }
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
