/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio Proposto 02 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <math.h>

#define MAX_ROW     100
#define MAX_LENGTH   31

int main(void)
{
  char surname[MAX_LENGTH];
  int i, n_row, m1, m2, m3, id, found;
  int matrix[MAX_ROW][2], mean;
  FILE *fs, *fm;

  /* open the files */
  fs = fopen("students.txt", "r");
  fm = fopen("marks.txt", "r");
  if (fs==NULL || fm==NULL) {
    printf("Error opening the input files.\n");
    return 1;
  }

  /* parse the mark file; generate the student marks */
  n_row = 0;
  while (fscanf(fm, "%d %d %d %d", &matrix[n_row][0], &m1, &m2, &m3) != EOF) {
    if (m1<15 || m2<15 || m3<15) {
      matrix[n_row][1] = -1;
    } else {
      mean = (m1+m2+m3) / 3.0;
      if (mean < 18) {
        matrix[n_row][1] = -1;
      } else {
        matrix[n_row][1] = ceil(mean);
      }
    }
    n_row++;
  }

  /* parse the student file; display results */
  while (fscanf(fs, "%s %d", surname, &id) != EOF) {
    found = 0;
    for (i=0; i<n_row && !found; i++) {
      if (id == matrix[i][0]) {
        if (matrix[i][1] < 0) {
          printf("%s failed\n", surname); 
        } else {
          printf("%s %d\n", surname, matrix[i][1]); 
        }
        found = 1;
      }
    }
  }

  fclose(fs);
  fclose(fm);
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
