/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio Proposto 03 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define  LENGTH  250

/* function prototypes */
int divide(int x, int y, int *q, int *r);

/*
 *  main program
 */
int main(int argc, char *argv[])
{
  int i, n, x, y, q, r;
  int array[LENGTH];
  FILE *fin, *fout;

  /* check command line */
  if (argc < 3) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <inputFile> <outputFile>\n", argv[0]);
    return 1;
  }

  /* open input file */
  if ((fin=fopen(argv[1], "r")) == NULL) {
    printf("Error opening the input file.\n");
    return 1;
  }

  /* parse input file */
  n = 0;
  while (n<LENGTH && fscanf(fin, "%d", &array[n])!=EOF) {
    n++;
  }
  fclose(fin);
  n /= 2; 

  /* open output file */
  if ((fout=fopen(argv[2], "w")) == NULL) {  
    printf("Error opening the output file.\n");
    return 1;
  }

  /* computation and print */
  for (i=0; i<n; i++) {
    x = array[i];
    y = array[i+n];
    if (divide(x, y, &q, &r) == 0) {
      fprintf(fout, "%d / %d = %d, R = %d\n", x, y, q, r);
    } else {
      fprintf(fout, "%d / %d = N/A, R = N/A\n", x, y);
    }
  }

  fclose(fout);
  return 0;
}

/* 
 *  compute the division x/y, quotient q and remainder r; return 1 upon errors
 */
int divide(int x, int y, int *q, int *r)
{  
  int i;

  if (y == 0) {
    return 1;
  }

  for (i=0; x>=y; i++) {
    x -= y;
  }

  *q = i;
  *r = x;
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
