/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 10 - Esercizio Proposto 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define MAX_NAME    20
#define MAX_DEGREE   6
#define NAME_OUT    "polydiff.txt"

/* function prototypes */
void clear(int poly[]);
void write(FILE *f, int poly[]);

/*
 *  main program
 */
int main(void)
{
  int c, d, poly[MAX_DEGREE], num_poly=0;
  char name[MAX_NAME];
  FILE *in, *out;

  printf("Input file name: ");
  scanf("%s", name);

  in = fopen(name, "r");
  out = fopen(NAME_OUT, "w");

  if (in==NULL || out==NULL) {
    printf("Error opening the files.\n");
  } else {
    fscanf(in, "%d", &num_poly);
    fprintf(out, "%d ", num_poly/2);

    clear(poly);
    while (num_poly > 0) {
      do {
        fscanf(in, "%d %d", &d, &c);
        poly[d] += (num_poly%2) ? (-c) : (c);
      } while (d!=0 || c!=0);
      if (num_poly % 2) { 
        write(out, poly);
        clear(poly);
      }
      num_poly--;
    }

    fclose(out);
    fclose(in);
  }
  return 0;
}

/*
 *  clear a poly
 */
void clear(int poly[])
{
  int i;

  for (i=0; i<MAX_DEGREE; i++) {
    poly[i] = 0;
  }
}

/*
 *  write a poly on file
 */
void write(FILE *f, int poly[])
{
  int i;

  for (i=MAX_DEGREE-1; i>=0; i--) {
    if (poly[i]) {
      fprintf(f, "%d %d ", i, poly[i]);
    }
  }
  fprintf(f, "0 0 ");
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
