/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 11 - Esercizio 02 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

/* structure declaration */
struct complex {
  float re;
  float im;
};

int main(int argc, char *argv[]) 
{
  struct complex c1, c2, cr;

  if (argc < 5) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <re1> <im1> <re2> <im2>\n", argv[0]);
    return 1;
  }

  c1.re = c1.im = c2.re = c2.im = 0;
  sscanf(argv[1], "%f", &c1.re);
  sscanf(argv[2], "%f", &c1.im);
  sscanf(argv[3], "%f", &c2.re);
  sscanf(argv[4], "%f", &c2.im);

  cr.re = c1.re*c2.re - c1.im*c2.im;
  cr.im = c1.re*c2.im + c1.im*c2.re;

  printf("Real part: %.2f\n", cr.re);
  printf("Imag part: %.2f\n", cr.im);
  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
