/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 11 - Esercizio 03 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <string.h>

#define MAX_CATEGORY  100
#define MAX_CODE        3

/* structure declaration */
struct sell {
  char code[MAX_CODE+1];
  float value;
  int num;
};

int main(int argc, char *argv[]) 
{
  struct sell array[MAX_CATEGORY];
  int n_category=0, idx, found;
  char code[MAX_CODE+1];
  float value;
  FILE *fp;

  if (argc < 3) {
    printf("Error: missing parameter.\n");
    printf("Run as: %s <input_file> <output_file>.\n", argv[0]);
    return 1;
  }

  if ((fp=fopen(argv[1], "r")) == NULL) {
    printf("Error: input file not readable.\n");
    return 1;
  }

  /* computation */
  while (fscanf(fp, "%*s%s%f", code, &value) != EOF) {
    found = 0;
    for (idx=0; idx<n_category && !found; idx++) {
      if (strcmp(code, array[idx].code) == 0) {
        array[idx].value += value;
        array[idx].num++;
        found = 1;
      }
    }
    if (!found && n_category<MAX_CATEGORY) {
      /* new category found */
      strcpy(array[idx].code, code);
      array[idx].value = value;
      array[idx].num = 1;
      n_category++;
    }
  }
  fclose(fp);

  /* output results */
  if ((fp=fopen(argv[2], "w")) == NULL) {
    printf("Error: output file not writeable.\n");
    return 1;
  }
  for (idx=0; idx<n_category; idx++) {
    fprintf(fp, "%s %d ", array[idx].code, array[idx].num);
    fprintf(fp, "%.2f %.2f\n", array[idx].value, array[idx].value/array[idx].num);
  }
  fclose(fp);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
