/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 11 - Esercizio 04 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

/* structure declaration */
typedef struct {
  int num;
  int den;
} fraction_t;

/* function prototypes */
fraction_t input_fraction(int which);
fraction_t sum_fractions(fraction_t add1, fraction_t add2);

/*
 *  main program
 */
int main(void) 
{
  fraction_t add1, add2, res;

  add1 = input_fraction(1);
  add2 = input_fraction(2);
  res = sum_fractions(add1, add2);
  printf("Result: %d / %d\n", res.num, res.den);
  return 0;
}

/*
 *  fraction input
 */
fraction_t input_fraction(int which)
{
  fraction_t res;

  printf("Input fraction %d (format <num>/<den>): ", which);
  scanf("%d/%d", &res.num, &res.den);
  if (res.den < 0) {
    res.num = -res.num;
    res.den = -res.den;
  }

  return res;
}

/*
 *  fraction sum, with result minimization
 */
fraction_t sum_fractions(fraction_t add1, fraction_t add2)
{
  fraction_t res = {0, 0};
  int min, i, sign;

  /* check for correctness */
  if ((add1.den == 0) || (add2.den == 0)) {
    return res;
  }

  /* sum */
  res.den = add1.den * add2.den;
  res.num = add1.num * add2.den + add2.num * add1.den;

  /* minimize */
  sign = (res.num < 0) ? -1 : 1;
  res.num *= sign;
  min = res.num > res.den ? res.den : res.num;
  for (i=min; i>1; i--) {
    if ((res.num%i == 0) && (res.den%i == 0)) {
      res.num /= i;
      res.den /= i;
    }
  }
  res.num *= sign;

  return res;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
