/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 * Capitolo 11 - Esercizio Proposto 01 - Soluzione 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

/* structure declaration */
struct point {
  float x, y, z;
};

int main(void) 
{
  struct point curr, center;
  int n_points=0;
  char name[20];
  FILE *fp;

  printf("Input file name: ");
  scanf("%s", name);
  if ((fp=fopen(name, "r")) == NULL) {
    printf("Error opening the input file.\n");
    return 1;
  }

  center.x = center.y = center.z = 0;
  while (fscanf(fp, "%f%f%f", &curr.x, &curr.y, &curr.z) != EOF) {
    center.x += curr.x;
    center.y += curr.y;
    center.z += curr.z;
    n_points++;
  }
  fclose(fp);

  if (n_points > 0) {
    center.x /= n_points;
    center.y /= n_points;
    center.z /= n_points;
  }
  printf("Baricenter coordinates: ");
  printf("%.3f %.3f %.3f\n", center.x, center.y, center.z);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2016
 *
 * Sergio Nocco   Stefano Quer
 * Guida alla Programmazione in Linguaggio C
 * Volume I: Fondamenti di programmazione
 *
 */
